stages:
  - AS
  - IHM
  - Activation_fail
  - BUILD & INSTALL
  - Deploy
variables:
  Environnement: 
    value: ""
    description: "env,int,metro,preprod,prod,qualif"
  goroco:
    value: "" 
    description: "Version a activer / Version de la configuration Confetti / Version a installer / Version a supprimer"
  server:
    value: "" 
    description: "Serveur(s) cible(s): dev-as, dev-ihm, i-as01, i-as0, i-as1, i-as01, i-ws23, i-ws2, i-ws3, metro-as, metro-ihm, u-as12, u-as1, u-as2, u-ws12, u-ws1, u-ws2, as12, as1, as2, ws12, ws1, ws2, qua-as, qua-ihm"
  application: 
    value: ""
    description: "as, ihm"
  instance:
    value: ""
    description: "Instance cible : m54app, m54app2"
  repositoryArtifactory:
    value: ""
    description: "Type de package: SNAPSHOT, RELEASE"
  rollback:
    value: ""
    description: "Activer le rollback automatique ? YES, NO"
  serverRestart:
    value: " false"
    description: "Arret/Relance Apache-Tomcat apres redeploiement de la config (true, false)"
  DEPLOY_PREINSTALL:
    value: "true"
    description: "activer ou desactiver la pre-installation (true, false)"
  Install_OPSH:
    value: ""
    description: "activer ou desactiver le deploiement opsh (COMPLET = ecrase le opsh.conf, MAJ = recupere celui de la derniere version, NON)"
  confirmation:
    value: ""
    description: "Confirmation suppression (YES, NO)"
  QUALITY: 
    value: "false"
    description: "activer ou desactiver Qualité SONAR"
  NR:
    value: "false"
    description: "activer ou desactiver les tests NR"
  PACK_AND_DEPLOY:
    value: "false"
    description: "activer ou desactiver les étapes packaging+livraison"
  SECURITY:
    value: "false"
    description: "activer ou desactiver la sécurité OwaspZAP"
  LIVRAISON:
    value: "false"
    description: "activer ou desactiver la livraison snapshot (force l etape packaging)"
  inventory: 'env/staging/$Environnement'
  MVN_TOOL_ID: 'Apache Maven 3.2.5'
  MVN_SETTING_ID: 'com.orange.jenkinsci.plugins.configfiles.maven.UserMavenSettingsConfig-faas'
  MVN_OPTS: '-XX:MaxPermSize=512m'
  JAVA_8_VERSION_ID: 'Oracle JDK 8u112'
  ANSIBLE_VERSION: '2.8'
  ODE_APP_ID: '467'
  ODE_PARAM_USER: 'ownerUserName=adm54app'
  ODE_PLAYBOOK_FILE: "arfadet-$(application).yml"

###################################### Activation ###############################################

as-Activation:
  stage: AS
  rules:
    - if: ($Environnement != "" && $application == "as" && $goroco != "" && $server != "" && $instance != "") || $application == "AS"
      when: manual
  variables:
    ODE_PARAM_ARTIFACTS: "$inventory group_vars roles"
  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server" 
  script:
    - echo "Activating $application ..."
    - ode add-configuration -i $inventory -e "GOROCO=$goroco $ODE_PARAM_USER instance=$instance" -p "-l ${server} --tags=j-j" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION  
    - echo "Application $application activated successfully"

ihm-Activation:
  stage: IHM
  rules:
    - if: ($Environnement != "" && $application == "ihm" && $goroco != "" &&  $server != "" && $instance != "" && $rollback != "") || $application == "IHM"
      when: manual
  variables:
    ODE_PARAM_ARTIFACTS: "$inventory group_vars roles"
  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server" 
  script:
    - echo "Activating $application ..."
    - ode add-configuration -i $inventory -e "GOROCO=$goroco $ODE_PARAM_USER instance=$instance rollback=$rollback" -p "-l ${server} --tags=j-j" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION  
    - echo "Application $application activated successfully"

ihm-Activation_onFailure:
  stage: Activation_fail
  needs: 
    - job: ihm-Activation
  rules:
    - if: ($Environnement != "" && $application == "ihm" && $goroco != "" &&  $server != "" && $instance != "" && $rollback != "") || $application == "IHM"
      when: on_failure
  variables:
    ODE_PARAM_ARTIFACTS: "$inventory group_vars roles"

  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server" 
  script:
    - echo "Activating $application ..."
    - ode add-configuration -i $inventory -e "GOROCO=ROLLBACK $ODE_PARAM_USER instance=$instance rollback=NO" -p "-l ${server} --tags=j-j" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION  
    - echo "Application $application activated successfully"

###################################### Configuration ###############################################

as-Configuration:
  stage: AS
  rules: 
    - if: ($Environnement != "" && $application == "as" && $goroco != "" &&  $server != "" && $instance != "") || $application == "AS" 
      when: manual
  variables:
    ODE_PARAM_ARTIFACTS: "livraison $inventory group_vars roles downloadPL.ksh confetti.env"
  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server" 
  script:
  # Téléchargement package de configuration ???
    - sh "./downloadPL.ksh ${application} conf ${goroco} ${server}"
  # Lancement playbook par ODE : Configuration
    - ode add-configuration -i $inventory -e "$ODE_PARAM_USER instance=$instance" -p "-l ${server} --tags=conf" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION

ihm-configuration:
  stage: IHM
  rules:
    - if: ($Environnement != "" && $application == "ihm" && $goroco != "" &&  $server != "" && $instance != "") || $application == "IHM"  
      when: manual
  variables:
    ODE_PARAM_ARTIFACTS: "livraison $inventory group_vars roles downloadPL.ksh confetti.env"
  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server" 
  script:
  # Téléchargement package de configuration ???
    - ./downloadPL.ksh $application conf $goroco $server
  # Lancement playbook par ODE : Configuration
    - ode add-configuration -i $inventory -e "$ODE_PARAM_USER instance=$instance" -p "-l ${server} --tags=conf" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION
  
ihm-configuration-restart:
  stage: IHM
  rules:
    - if: ($serverRestart == "true" && $Environnement != "" && $application == "ihm" && $goroco != "" &&  $server != "" && $instance != "")  || $application == "IHM" 
      when: manual
    - if: $serverRestart == "false" 
      when: never
  variables:
    ODE_PARAM_ARTIFACTS: "livraison $inventory group_vars roles downloadPL.ksh confetti.env"
  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server" 
  script:
  # Téléchargement package de configuration ???
    - ./downloadPL.ksh $application conf $goroco $server
  # Lancement playbook par ODE : Configuration
    - ode add-configuration -i $inventory -e "$ODE_PARAM_USER instance=$instance" -p "-l ${server} --tags=confrestart" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION

###################################### PreInstall ###############################################

as-PreInstall:
  stage: AS
  rules:
    - if: ($Environnement != "" && $application == "as" && $goroco != "" &&  $server != "" && $instance != "" && $repositoryArtifactory != "" )  || $application == "AS" 
      when: manual
  variables:
    ODE_PARAM_ARTIFACTS: "livraison $inventory group_vars roles downloadPL.ksh confetti.env"
  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server | repositoryArtifactory $repositoryArtifactory" 
  script:
  # Téléchargement package de configuration ???
    - ./downloadPL.ksh $application app $goroco $repositoryArtifactory
  # Lancement playbook par ODE : PreInstall
    - ode add-configuration -i $inventory -e "GOROCO=$goroco $ODE_PARAM_USER instance=$instance" -p "-l $server --tags=j-1" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION

ihm-PreInstall-InstallOPSH:
  stage: IHM
  rules:
    - if: ($Install_OPSH != "NON" && $Environnement != "" && $application == "ihm" && $goroco != "" &&  $server != "" && $instance != "" && $repositoryArtifactory != "")  || $application == "IHM" 
      when: manual
  variables:
    ODE_PARAM_ARTIFACTS: "livraison $inventory group_vars roles downloadOPSH.ksh downloadPL.ksh confetti.env"

  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server | repositoryArtifactory $repositoryArtifactory" 
  script:
  # Telechargement package OPSH
    - ./downloadOPSH.ksh arfadet-opsh $goroco $repositoryArtifactory $instance
  # Téléchargement package de configuration ???
    - ./downloadPL.ksh $application conf $goroco $server
  # Telechargement package applicatif
    - ./downloadPL.ksh ${application} app ${goroco} ${repositoryArtifactory}
  # Lancement playbook par ODE : PreInstall
    - ode add-configuration -i $inventory -e "GOROCO=$goroco $ODE_PARAM_USER instance=$instance" -p "-l $server --tags=installOpsh" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION

ihm-PreInstall-DEPLOY_PREINSTALL:
  stage: IHM
  rules:
    - if: ($DEPLOY_PREINSTALL == "true" && $Environnement != "" && $application == "ihm" && $goroco != "" &&  $server != "" && $instance != "" && $repositoryArtifactory != "") || $application == "IHM" 
      when: manual
  variables:
    ODE_PARAM_ARTIFACTS: "livraison $inventory group_vars roles downloadOPSH.ksh downloadPL.ksh confetti.env"

  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server | repositoryArtifactory $repositoryArtifactory" 
  script:
  # Telechargement package OPSH
    - ./downloadOPSH.ksh arfadet-opsh $goroco $repositoryArtifactory $instance
  # Téléchargement package de configuration ???
    - ./downloadPL.ksh $application conf $goroco $server
  # Telechargement package applicatif
    - ./downloadPL.ksh ${application} app ${goroco} ${repositoryArtifactory}
  # Lancement playbook par ODE : PreInstall
    - ode add-configuration -i $inventory -e "GOROCO=$goroco $ODE_PARAM_USER instance=$instance" -p "-l $server --tags=j-1" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION

###################################### deploy-CFT ###############################################

as-deploy-CFT:
  stage: AS
  rules: 
    - if: ($Environnement != "" && $application == "ihm" && $goroco != "" &&  $server != "" && $instance != "" && $repositoryArtifactory != "") || $application == "AS" 
      when: manual
  variables:
    ODE_PARAM_ARTIFACTS: "livraison $inventory group_vars roles"
  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server | repositoryArtifactory $repositoryArtifactory" 
  script:
  # Téléchargement package de configuration ???
    - sh "./downloadPL.ksh $application cft $goroco $repositoryArtifactory"
  # Lancement playbook par ODE : Configuration
    - ode add-configuration -i $inventory -e "GOROCO=$goroco $ODE_PARAM_USER instance=$instance" -p "-l $server --tags=cft" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION

########################################## Suppression #########################################

as-Suppression:
  stage: AS
  rules:
    - if: ($confirmation == "YES" && $Environnement != "" && $application == "as" && $goroco != "" &&  $server != "" && $instance != "" && $repositoryArtifactory != "") || $application == "AS" 
      when: manual
  variables:
    ODE_PARAM_ARTIFACTS: "$inventory group_vars roles"
  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server | confirmation $Confirmation" 
  script:
    - ode add-configuration -i $inventory -e "GOROCO=$goroco $ODE_PARAM_USER instance=$instance CONFIRM_DROP=$confirmation" -p "-l $server --tags=drop" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION

ihm-Suppression:
  stage: IHM
  rules:
    - if: ($confirmation == "YES" && $Environnement != "" && $application == "ihm" && $goroco != "" &&  $server != "" && $instance != "" && $repositoryArtifactory != "") || $application == "IHM" 
      when: manual
  variables:
    ODE_PARAM_ARTIFACTS: "$inventory group_vars roles"
  before_script:
    - echo "goroco  $goroco | application  $application | inventory $inventory | server $server | confirmation $Confirmation" 
  script:
    - ode add-configuration -i $inventory -e "GOROCO=$goroco $ODE_PARAM_USER instance=$instance CONFIRM_DROP=$confirmation" -p "-l $server --tags=drop" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION



#################################### DEPLOY #########################################

deploy-with-ODE:
  stage: Deploy
  rules:
    - if: ($confirmation == "YES" && $Environnement != "" && $application == "ihm" && $goroco != "" &&  $server != "" && $instance != "" && $repositoryArtifactory != "") || $application == "IHM" 
      when: manual
  script: 
    # Téléchargemet du package de conf
    - "./downloadPL.ksh ihm conf $GOROCO $params.server"
    - ode add-configuration -i $inventory -e "GOROCO=$goroco $ODE_PARAM_USER instance=$instance rollback=NO" -p "-l $server --tags=pipeline" -c ansible.cfg arfadet-$(application).yml
    - ode add-artifact $ODE_PARAM_ARTIFACTS
    - ode deploy -t $ODE_APP_ID -A $ANSIBLE_VERSION

######################################## BUILD ########################################

as-build:
   stage: BUILD & INSTALL
   variables:
     RUN_SONAR: $QUALITY
   rules:
#     - if: ($Environnement != "" && $application == "as" && $goroco != "" &&  $server != "" && $instance != "" && $Deploy != "" && NR != "" && LIVRAISON != "" && LIVRAISON_CFT != "") || $application == "as" 
#       when: manual
     - when: manual
   trigger:
       project: karim.abnane/arfadet-as
       branch: main
       strategy: depend

ihm-build:
   stage: BUILD & INSTALL
   variables:
     RUN_SONAR: $QUALITY
   rules:
#     - if: ($confirmation == "YES" && $Environnement != "" && $application == "ihm" && $goroco != "" &&  $server != "" && $instance != "" && $repositoryArtifactory != "") || $application == "ihm" 
#       when: manual
     - when: manual      
   trigger:
       project: karim.abnane/arfadet-ihm
       branch: main
       strategy: depend
    